
#include "shared.h"

int fail = 0;
int flags = 0;

unsigned int nCrc;
unsigned short addresses[32];

int nLen;
unsigned char *src;

#define check_fail() if (fail) { \
			printf ("\nPress \'Enter\' to exit.\n"); \
			gets (exit);		\
			free (src);		\
			return 0; 		\
		}				\

int main()
{
	int not_encrypted = 0;

	FILE *fz;
	char szName[256], szName1[256], exit[4];

	fz = fopen("info.dat", "rb");
	if (fz == NULL)
		write_info_dat();
	else
		fclose (fz);

	fz = fopen("_DS_MENU.DAT", "rb");

	if (fz == NULL) {
		printf ("Please type the complete file name (eg. _DS_MENU.DAT)\n");
		gets (szName);
		fz = fopen(szName, "rb");
	} else {
		strcpy (szName, "_DS_MENU.DAT");
	}

	if (fz == NULL) 
	{
		printf ("%s was not found.\n", szName);
		fail = 1;
	}

	check_fail();

	fseek (fz, 0, SEEK_END);
	nLen = ftell (fz);
	rewind (fz);

	src = (unsigned char*)malloc( nLen );

	fread (src, 1, nLen, fz);
	fclose (fz);
	
	nCrc = crc32();		// Check crc32

	if (src[0xAC] == 'P' && src[0xad] == 'A' && src[0xae] == 'S' && src[0xaf] == 'S')
	{
		not_encrypted = 1;
	}

	if (!not_encrypted) {
		crypt(0);		// decrypt
	}

	check_fail();

	db_check();		// Get and display info

	check_fail();

	apply_patches();	// apply hardware patches

	check_fail();

	if (not_encrypted) {
		printf ("\nWould you like to encrypt this for use on an R4/M3DSS Cart?\n");
		gets(exit);

		if (exit[0] == 'Y' || exit[0] == 'y') not_encrypted = 0;
	}

	if (!not_encrypted) {
		crypt(1);		// encrypt
	}

	strcpy (szName1, szName);
	strcat (szName1, ".old");
	rename (szName, szName1);

	fz = fopen(szName, "wb");
	fwrite (src, 1, nLen, fz);	
	fclose (fz);

	fail = 1;	// Didn't really fail
	check_fail();
}
